
#include <stdlib.h>
#include <math.h>

// May need to change this include to customize to your environment
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include "st.h"

// Current size of the OpenGL window
int windowSizeX;
int windowSizeY;


STScene scene;				// The scene graph
STSceneNode* square_node;	// The node containing the square

// The joystick we're going to use
STJoystick* js = NULL;

STTimer timer;

static void setup(char* tex_fname) {
	// Initialize the joystick system
	STJoystick::Initialize();
	
	/*** CS148 TODO
	 *   Fill in this section with setup code.  At a minimum you
	 *   need to open a joystick for use.  This is also a good
	 *   place to print out information about the available joysticks.
	 */

	// Set up a simple scene
	STSceneNode* root = scene.GetRoot();
	STShape* square = STShape::CreateRect(1.f, 1.f);
	square->SetColor(STColor(1.f, 1.f, 1.f));
	// Try to use the specified texture
	STImage square_teximage;
	if (square_teximage.Load(tex_fname) != ST_OK) {
		printf("Error opening %s, continuing without it.\n", tex_fname);
	}
	else {
		STTexture* square_tex = new STTexture();
		square_tex->Upload(square_teximage);
		square->SetTexture(square_tex);
	}
	square_node = root->PlaceObj(square);

	timer.Reset();
}

static void idle() {

	/*** CS148 TODO
	 *   Fill in the idle function with code that will:
	 *     1) Update joystick state
	 *     2) Check and do some filtering on the updated state
	 *     3) Update the state of the scene graph (i.e. update
	 *        transforms)
	 *
	 *   Note that you probably want to use a timer to
	 *   get frame rate independent movement.
	 */

	glutPostRedisplay();
}

static void display() {
	glClearColor(.3f, .3f, .3f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0., 0., 5.f, 0., 0., 0., 0., 1., 0.);
	
	scene.Draw();

	glutSwapBuffers();
}

// Keyboard event handler:
static void keyboard(unsigned char key, int x, int y) {
	switch (key) {
		// quit
		case char(27):
		case 'q':
		case 'Q':
			exit(0);
	}
}

void reshape(int w, int h) {
	windowSizeX = w;
	windowSizeY = h;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

	gluPerspective(60., double(windowSizeX) / double(windowSizeY), .01, 100.);
	glViewport(0, 0, w, h);

	glMatrixMode(GL_MODELVIEW);

	glutPostRedisplay();
}

int main(int argc, char** argv) {

	if (argc != 2) {
		printf("Usage: %s texture_file\n", argv[0]);
		return -1;
	}
	char* texture_fname = argv[1];

	glutInit(&argc, argv);
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition(20,20);
	glutInitWindowSize(512, 512);
	glutCreateWindow("CS148 - Assignment 4");

	glEnable(GL_DEPTH_TEST);
	
	setup(texture_fname);

	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutReshapeFunc(reshape);
	glutIdleFunc(idle);
	glutMainLoop();

	return 0;
}

