
#ifndef __STTIMER_H__
#define __STTIMER_H__


#ifdef _WIN32
#include <windows.h>
#else
#include <sys/time.h>
#endif

/**
* Platform independent timer class.
* Keeps track of elapsed wall clock time and returns values in milliseconds.
*/
class STTimer {

	public:
		STTimer();

		void   Reset();
		float  GetElapsedMillis();

	private:

#ifdef _WIN32
	LARGE_INTEGER mStartTime;
	float		  mFrequency;

#else
	struct timeval mStartTime;
#endif

};


#endif // __STTIMER_H__

